﻿using C1.DataEngine;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Dynamics365Analytics
{
    public partial class Form1 : Form
    {
        DataTable OpportunityTable;
        C1.DataEngine.Workspace ws;
        public Form1()
        {
            InitializeComponent();
        }
        private void GetD365Data(string path)
        {
            var config = Properties.Settings.Default;
            string extendProperties = "{\"resource\":\"" + config.Resource + "\"}";
            var conectionStr = $@"Url={config.UrlDynamics};Use Etag=true;OAuth Client Id={config.ClientID};OAuth Client Secret={config.ClientSecret};OAuth Token Endpoint={config.TokenEndpoint};OAuth Extend Properties={extendProperties};
                            Use Cache=true;Cache Tolerance=500;Cache Location='C:\temp\c1cache.db';Max Page Size = 100";

            C1.AdoNet.D365S.C1D365SConnection con = new C1.AdoNet.D365S.C1D365SConnection();
            con.ConnectionString = conectionStr;
            string sql = "select * from opportunities;";
             using(con)
            {
                con.Open();
                var cmd = new C1.AdoNet.D365S.C1D365SCommand(con);
                cmd.CommandText = sql;
                //var reader = cmd.ExecuteReader();
                //OpportunityTable.Load(reader);
              //  DataTable databaseTables = con.GetSchema("Tables");
                ws = new C1.DataEngine.Workspace();
                ws.Init(path);
                var connector = new DbConnector(ws, con,cmd);
                connector.GetData("Opportunities");

            }
                
        }

        private void InitializeWorkspace(string path)
        {
           
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            GetD365Data(@"C:\Cache\D365SWS");
        }
    }
}
